/*
 *  Copyright (c) 1996 Rainbow Technologies Inc, Internet Security Group. 
 *  All rights reserved.
 *
 *  Name:           csdevid.h
 *
 *  Description:    defines for PCI Device ID
 *
 *  logs:
 *    07/25/96      Initial revision. <ffan>
 *
 * $Archive:: /Source/Driver/Linux24/csdevid.h                        $
 * $Date: 2002/10/01 02:55:50 $
 * $Revision: 1.1.1.1 $
 * $History:: csdevid.h                                               $
 * 
 * *****************  Version 1  *****************
 * User: Wwang        Date: 5/11/01    Time: 3:08p
 * Created in $/Source/Driver/Linux24
 * add support for CS3, HSM and Mercury.
 * 
 * *****************  Version 4  *****************
 * User: Seanlee      Date: 8/23/00    Time: 2:45p
 * Updated in $/Source/SwiftAPI 6.x.x (supports all cards)/include
 * 
 * *****************  Version 3  *****************
 * User: Seanlee      Date: 8/22/00    Time: 4:03p
 * Updated in $/Source/SwiftAPI 6.x.x (supports all cards)/include
 * Add support for ns2000 card
 * 
 * *****************  Version 2  *****************
 * User: Seanlee      Date: 7/31/00    Time: 2:26p
 * Updated in $/Source/SwiftAPI 5.x.x (supports all cards)/include
 * Add support for displaying SUN's string according to SUN's vendor
 * id.
 * 
 * *****************  Version 1  *****************
 * User: Seanlee      Date: 6/17/99    Time: 11:50a
 * Created in $/Source/swift501/include
 * This release combines swiftapi 2.0.7, 2.0.8, 2.1.1, and 4.1.13 and
 * supports CryptoSwift and Netswift Cards.
 * 
 * *****************  Version 11  *****************
 * User: Seanlee      Date: 2/10/99    Time: 4:58p
 * Updated in $/Source/new SwiftAPI 2.1.x, 3.x.x/include
 * 
 * *****************  Version 10  *****************
 * User: Seanlee      Date: 2/10/99    Time: 4:38p
 * Updated in $/Source/new SwiftAPI 2.1.x, 3.x.x/include
 * 
 * *****************  Version 9  *****************
 * User: Mjohnson     Date: 12/07/98   Time: 2:00p
 * Updated in $/Source/new SwiftAPI/include
 * 
 * *****************  Version 8  *****************
 * User: Mjohnson     Date: 12/07/98   Time: 1:56p
 * Updated in $/Source/new SwiftAPI/include
 * added calling convention info for mac port
 * 
 * *****************  Version 7  *****************
 * User: Gpowell      Date: 12/03/98   Time: 4:38p
 * Updated in $/Source/new SwiftAPI/include
 * 
 * *****************  Version 5  *****************
 * User: Gpowell      Date: 11/16/98   Time: 1:40p
 * Updated in $/Source/new SwiftAPI/include
 * 
 * *****************  Version 7  *****************
 * User: Ffan         Date: 9/04/98    Time: 5:41p
 * Updated in $/Source/new SwiftAPI without Secure Key Storage/include
 * 
 * *****************  Version 6  *****************
 * User: Ffan         Date: 9/04/98    Time: 5:38p
 * Updated in $/Source/new SwiftAPI without Secure Key Storage/include
 * 
 * *****************  Version 5  *****************
 * User: Ffan         Date: 9/04/98    Time: 5:34p
 * Updated in $/Source/new SwiftAPI without Secure Key Storage/include
 * 
 * *****************  Version 4  *****************
 * User: Ffan         Date: 5/13/98    Time: 4:55p
 * Updated in $/Source/new SwiftAPI without Secure Key Storage/include
 * Only inline on Linux.
 * 
 * *****************  Version 3  *****************
 * User: Ffan         Date: 4/17/98    Time: 11:08a
 * Updated in $/Source/new SwiftAPI without Secure Key Storage/include
 * 
 * *****************  Version 8  *****************
 * User: Ffan         Date: 3/30/98    Time: 2:04p
 * Updated in $/Source/Driver/Linux20
 * 
 * *****************  Version 7  *****************
 * User: Ffan         Date: 3/30/98    Time: 2:01p
 * Updated in $/Source/Driver/Linux20
 * 
 * *****************  Version 6  *****************
 * User: Ffan         Date: 3/26/98    Time: 6:43p
 * Updated in $/Source/Driver/Linux20
 * Support FastMAP
 * 
 * *****************  Version 5  *****************
 * User: Ffan         Date: 12/10/97   Time: 12:44p
 * Updated in $/Source/Driver/NT40/sys
 * 
 * *****************  Version 4  *****************
 * User: Ffan         Date: 8/04/97    Time: 2:57p
 * Updated in $/Source/Driver/BSDi30
 * 
 * *****************  Version 3  *****************
 * User: Ffan         Date: 8/01/97    Time: 4:17p
 * Updated in $/Source/Driver/BSDi30
 * 
 * *****************  Version 2  *****************
 * User: Ffan         Date: 7/31/97    Time: 2:40p
 * Updated in $/Source/Driver/BSDi30
 * Change "fun" and "ver" to 6-bit each in size.
 * 
 * *****************  Version 1  *****************
 * User: Ffan         Date: 7/25/97    Time: 5:31p
 * Created in $/Source/Driver/Linux20
 * Definition of DeviceID partition
 *
 */
#ifndef _CSDEVID_H_
#define _CSDEVID_H_

/*
 * ISG Vendor ID and device IDs
 */
#define ISG_VENDOR_ID	    0x12de
#define B200_DEVICE_ID	    0x0200
#define B200S_DEVICE_ID	    0x0204
#define B50_DEVICE_ID       0x0201
#define B100_DEVICE_ID      0x0203
#define HSM_DEVICE_ID       0x0400
#define CS3_DEVICE_ID       0x1200
#define NS2000_DEVICE_ID    0x1300
#define DEVID_FUN_CS3		DEVID_FUN(CS3_DEVICE_ID)
#define DEVID_VER_CS3		DEVID_VER(CS3_DEVICE_ID)

/*
 * PCI Vendor ID
 */
#define HP_VENDOR_ID  0x103c

/* sal */
#define SUN_VENDOR_ID 0x108e
#define SUN_DEVICE_ID 0x3de7
/* sal end */

/*
 * NS2000 Device ID
 */

#define NS2000_DEVICE_ID 0x1300


/*
 * defines if not defined elsewhere
 */
#ifndef VAL_INTCLEAR_BETA
#define  VAL_INTCLEAR_BETA 0x203F1000
#define  VAL_INTCLEAR_V1   0x023F1000
#endif

#ifndef USE_OPREG
#define  USE_OPREG	   0x00000010
#endif

#ifndef USE_FASTMAP_IOREG
#define USE_FASTMAP_IOREG      0x00000040
#endif

#define  VAL_INTCLEAR_NS2000	0x023F0000			/* for NS2000 */

#ifndef USE_NS2000_IOREG
#define USE_NS2000_IOREG      0x00000080
#endif

 
 /* ---------------------------------------------------------------- 
 * DeviceID and VendorID
 * ---------------------------------------------------------------- */
#define DEVID_ICD_SBIT   12
#define DEVID_FUN_SBIT   6
#define DEVID_VER_SBIT   0

#define DEVID_ICD_MASK   0xf000
#define DEVID_FUN_MASK   0x0fc0
#define DEVID_VER_MASK   0x003f

/* macro to extract fields from device ID */
#define DEVID_ICD(did)   ( ((did)&DEVID_ICD_MASK) >> DEVID_ICD_SBIT )
#define DEVID_FUN(did)   ( ((did)&DEVID_FUN_MASK) >> DEVID_FUN_SBIT )
#define DEVID_VER(did)   ( ((did)&DEVID_VER_MASK) >> DEVID_VER_SBIT ) 

/* macro to form device ID */
#define DEVID_CONCAT(icd, fun, ver) ((icd)<<DEVID_ICD_SBIT | (fun)<<DEVID_FUN_SBIT | (ver))

/* maximum vale that each ICD category can go */
#define DEVID_FUN_MAX    (72)  /* 64 takes tooooo... long to start a driver */
                               /* increased to cover CS3's device ID        */
#define DEVID_VER_MAX    (16)  /* 64 takes tooooo... long to start a driver */

/* defines for public key ICD */
#define DEVID_ICD_PUBLIC 0x0000

/* RNG */
#define DEVID_FUN_RNG 0x4

/* fastMAP function # */
#define DEVID_FUN_FASTMAP 0x8

/* sal */
#define DEVID_FUN_SUN   DEVID_FUN(SUN_DEVICE_ID)
#define DEVID_VER_SUN   DEVID_VER(SUN_DEVICE_ID)

/* ns2000 function  */
#define DEVID_FUN_NS2000	DEVID_FUN(NS2000_DEVICE_ID)
#define DEVID_VER_NS2000	DEVID_VER(NS2000_DEVICE_ID)


typedef struct _DidVersion {
  unsigned short ver;          /* version */
  char*          name;         /* name of this version */
  unsigned long  intclear;     /* value to clear the interrupt register */
  int            flags;        /* do this version need access to OP reg? */
} DidVersion;

typedef struct _DidFunction {
  unsigned short fun;
  char*          name;
} DidFunction;

typedef struct _VendorInfo {
  unsigned short vid;
  char*          name;
} VendorInfo;

/* 
 * list of known version at the time of writing 
 */
static const DidVersion knownVersions[] = {
  {0x0, "Beta", VAL_INTCLEAR_BETA, USE_OPREG },
  {0x1, "v1.0", VAL_INTCLEAR_V1,   0 },
  {0x2, "v1.1", VAL_INTCLEAR_V1,   0 },
  {DEVID_VER_SUN, "\0", VAL_INTCLEAR_V1, 0},
};

static const DidVersion knownNS2000Versions[] = {
  {0x1, "v1.0", VAL_INTCLEAR_V1,   0 },
  {0x2, "v1.1", VAL_INTCLEAR_V1,   0 },
  {DEVID_VER_SUN, "\0", VAL_INTCLEAR_V1, 0},
};



#define numKnownVersion ( sizeof(knownVersions) / \
                          sizeof(DidVersion) )

static const DidVersion fastmapKnownVersions[] = {
  {0x0, "\0", VAL_INTCLEAR_V1, USE_FASTMAP_IOREG },
};
#define numFastmapKnownVersion ( sizeof(fastmapKnownVersions) / \
                                 sizeof(DidVersion) )


static const DidVersion netswiftKnownVersions[] = {
  {0x0, "\0", VAL_INTCLEAR_NS2000, USE_NS2000_IOREG },
};
#define numNetswiftKnownVersion ( sizeof(netswiftKnownVersions) / \
                                 sizeof(DidVersion) )

static const DidVersion cs3KnownVersions[] = {
  {0x1, "v1.0", 0x001F1000, USE_FASTMAP_IOREG },
};

/* default value if the device version is not listed */
static const DidVersion unknownVersion = {
  0xffff /* dont care*/, "", VAL_INTCLEAR_V1, 0
};

#define oemVersion fastmapKnownVersions

/* 
 * list of known function 
 */
static const DidFunction knownFunctions[] = {
  {0x0, "CryptoSwift Accelerator"},
  {DEVID_FUN_RNG, "CryptoSwift RNG"},
  {DEVID_FUN_FASTMAP , "CryptoSwift FastMAP"},
	{DEVID_FUN_NS2000, "NetSwift 2000"},
}; 
#define numKnownFunction ( sizeof(knownFunctions) / \
                           sizeof(DidFunction) )

/* default value if the device function is not listed */
static const DidFunction unknownFunction = {
  0x0,  "CryptoSwift Accelerator"
};

static const DidFunction oemFunction = {
  DEVID_FUN_FASTMAP, ""
};

/* 
 * list of known vendors
 */
static const VendorInfo vendorRainbow = {
  ISG_VENDOR_ID, "" 
};

static const VendorInfo knownVendors[] = {
  {HP_VENDOR_ID, "Praesidium PKC Accelerator Card"},
  {SUN_VENDOR_ID, "Sun Crypto Accelerator"},
  {0,      "OEM Secure Server Accelerator"}
};
#define numKnownVendor ( ( sizeof(knownVendors) / sizeof(VendorInfo) ) - 1 )

/* 
 * inline function to retrieve configuration for a particular version 
 */
static 
#if defined(WIN32)
__inline
#elif defined(macintosh)
#elif defined(LINUX)
inline
#endif /* ulgy... */
void getDidConfig(
  unsigned short device_id,
  DidVersion** ppdver,
  DidFunction** ppdfun
  )
{
  int i;
  unsigned char  ver;
  unsigned short fun;

  ver = DEVID_VER(device_id);
  fun = DEVID_FUN(device_id);

  *ppdfun = (DidFunction*)knownFunctions;
  for( i=0; i<numKnownFunction; ++i, ++*ppdfun ) {
    if( (*ppdfun)->fun == fun )
      break;
  }
  if( i >= numKnownFunction )
    (*ppdfun) = (DidFunction*)&unknownFunction;

  /* fastMAP */
  if( (*ppdfun)->fun == DEVID_FUN_FASTMAP  ) {   
    *ppdver = (DidVersion*)fastmapKnownVersions;
  }
  else if ((*ppdfun)->fun == DEVID_FUN_NS2000) {
		*ppdver = (DidVersion*)netswiftKnownVersions;
	}
  else if ((*ppdfun)->fun == DEVID_FUN(CS3_DEVICE_ID)) {
    *ppdver = (DidVersion*)cs3KnownVersions;
  }
  else {
    *ppdver = (DidVersion*)knownVersions;
    for( i=0; i<numKnownVersion; ++i, ++*ppdver ) {
      if( (*ppdver)->ver == ver )
        break;
    }
    if( i >= numKnownVersion )
      (*ppdver) = (DidVersion*)&unknownVersion;
  }
}

/* 
 * inline function to retrieve configuration for a particular version 
 */
static 
#if defined(WIN32)
__inline
#elif defined(macintosh)
#elif defined(LINUX)
inline
#endif /* ulgy... */
void getPciIdConfig(
  unsigned long id,
  DidVersion** ppdver,
  DidFunction** ppdfun,
  VendorInfo** ppdvi
  )
{
  unsigned short device_id;
  unsigned short vendor_id;

  device_id = (unsigned short) (id & 0xffff);      /* sal for getting rid of warning... */
  vendor_id = (unsigned short) (id >> 16);

  if( (vendor_id == 0) || (vendor_id == ISG_VENDOR_ID) )
  {
    (*ppdvi) = (VendorInfo*)&vendorRainbow;
    getDidConfig( device_id, ppdver, ppdfun );
  }
  else
  {
    int i;
    (*ppdvi) = (VendorInfo*)knownVendors;
    for( i=0; i<numKnownVendor; ++i, ++*ppdvi )
    {
      if( (*ppdvi)->vid == vendor_id )
        break;
    }
    (*ppdfun) = (DidFunction*)&oemFunction;
    (*ppdver) = (DidVersion*)&oemVersion;
  }
}

/******************************************************************************
* The following data and code are intended to replace 
 
* GetPciIdConfig() and GetDIdConfig() and associated tables. 
*
* A entry must be created in the known device table for every device type to
* be supported.
*******************************************************************************/
typedef struct deviceParams
{
    unsigned short vendorId;     /* 16 bit PCI vendor ID                   */
    char *vendorName;            /* vendor/product name                    */
    unsigned short deviceId;     /* 16 bit PCI device ID                   */
    char *functionName;          /* function name                          */
    char *versionName;           /* version text                           */
    unsigned long  intclear;     /* value to clear the interrupt register  */
    int flags;                   /* sspecial flags for driver to reference */
} DEVICE_PARAMS;

/* Known device's information */
static const DEVICE_PARAMS knownDevices[] =
{
{ ISG_VENDOR_ID, "", B200_DEVICE_ID,  "CryptoSwift FastMAP", "\0", VAL_INTCLEAR_V1, USE_FASTMAP_IOREG },
{ ISG_VENDOR_ID, "", B200S_DEVICE_ID,  "CryptoSwift FastMAP", "\0", VAL_INTCLEAR_V1, USE_FASTMAP_IOREG },
{ ISG_VENDOR_ID, "", B50_DEVICE_ID,   "CryptoSwift FastMAP", "\0", VAL_INTCLEAR_V1, USE_FASTMAP_IOREG },
{ ISG_VENDOR_ID, "", B100_DEVICE_ID,  "CryptoSwift FastMAP", "\0", VAL_INTCLEAR_V1, USE_FASTMAP_IOREG },
{ ISG_VENDOR_ID, "", HSM_DEVICE_ID,  "CryptoSwift HSM", "\0", VAL_INTCLEAR_V1, USE_FASTMAP_IOREG },
{ ISG_VENDOR_ID, "", CS3_DEVICE_ID,   "CryptoSwift FASTMAP2", "\0", 0x001F1000, USE_FASTMAP_IOREG },
{ HP_VENDOR_ID, "Praesidium PKC Accelerator Card",B200_DEVICE_ID, "", "\0", VAL_INTCLEAR_V1, USE_FASTMAP_IOREG},
{0,             "OEM Secure Server Accelerator",  B200_DEVICE_ID, "", "\0", VAL_INTCLEAR_V1, USE_FASTMAP_IOREG},
};


/* Unknown device's information */
static const DEVICE_PARAMS unknownDevice =
{ 0, "", DEVID_CONCAT(0, 0, 0xffff), "CryptoSwift Accelerator", "", VAL_INTCLEAR_V1, 0};

/* GetDeviceData() - get PCI device parameters from hardware ID 
 *
 * Arguments:    id -         hardware ID of a device
 *               pDevParams - pointer to a location to receive the address of the device 
 *                            parameter entry 
 * Description:  
 */
static 
#if defined(WIN32)
__inline
#elif defined(macintosh)
#elif defined(LINUX)
inline
#endif 
void GetDeviceData( unsigned long id, DEVICE_PARAMS **pDevParams) 
{
  int i;

  /* assume unknown device first */
  *pDevParams = (DEVICE_PARAMS *)&unknownDevice;
 
  /* search the known device table for a device with the same vendor ID and device ID */
  for (i=0; i < sizeof(knownDevices)/sizeof(knownDevices[0]); i++)
	{
	if ( id == ((unsigned long)(knownDevices[i].vendorId)<<16) + knownDevices[i].deviceId )
		{
		(*pDevParams) = (DEVICE_PARAMS *)&knownDevices[i];
		return;
		}
	}
}
/* ---------------------------------------------------------------- 
 * end of device id 
 * ---------------------------------------------------------------- */
#endif /* _CSDEVID_H_ */
