/*
 *  Copyright (c) 1996 Rainbow Technologies Inc, Internet Security Group. 
 *  All rights reserved.
 *
 *  @(#)swiftype.h  1.0.1    04/15/97
 *
 *  Description:    type definition for SwiftAPI and driver
 *
 *  Author:         ffan
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL RAINBOW
 * TECHNOLOGIES BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN 
 * AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION 
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *  
 * This source code is subject to the U.S. Export Administration Regulations and 
 * other U.S. law, and may not be exported or re-exported to certain countries 
 * (currently Afghanistan (Taliban-controlled areas), Cuba, Iran, Iraq, Libya, 
 * North Korea, Serbia (except Kosovo), Sudan and Syria) or to persons or entities 
 * prohibited from receiving U.S. exports (including Denied Parties, entities on 
 * the Bureau of Export Administration Entity List, and Specially Designated 
 * Nationals). 
 *  
 * Permission is hereby granted, free of charge, to any person meeting the export 
 * regulations above to deal in this software and associated documentation files 
 * (the "Software"), without restriction, including without limitation the rights 
 * to use, copy, modify, and merge copies of the Software, and to permit persons 
 * to whom the Software is furnished to do so, subject to the following conditions:
 *  
 * 1.  The above copyright notice and this permission notice shall be included in all 
 * copies or substantial portions of the Software.
 * 
 */

#ifndef _SWIFTYPE_H_
#define _SWIFTYPE_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

typedef long              SW_STATUS;              /* status           */
typedef unsigned char     SW_BYTE;                /* 8 bit byte       */
typedef unsigned short    SW_U16;                 /* 16 bit number    */
#if defined(_IRIX)
#include <sgidefs.h>
typedef __uint32_t        SW_U32;
#elif defined(_HPUX_SOURCE)
#include <sys/types.h>
typedef uint32_t          SW_U32;
#else
typedef unsigned long     SW_U32;                 /* 32 bit integer   */
#endif

#if defined(WIN32)
  typedef struct _SW_U64 {
      SW_U32 low32;
      SW_U32 high32;
  } SW_U64;                                         /* 64 bit integer   */
#elif defined(MAC)
  typedef longlong SW_U64
#else /* Unix variants */
  typedef struct _SW_U64 {
      SW_U32 low32;
      SW_U32 high32;
  } SW_U64;                                         /* 64 bit integer   */
#endif 

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _SWIFTYPE_H_ */

